:-module(prim_dynamic,[prim_assertFact/2,prim_retractFact/2,prim_getDynamicKnowledge/1,prim_abortTransaction/1,prim_commitTransaction/2,prim_startTransaction/1,prim_isKnownAtTime/3,abortTransaction/0,initializeDynamic/0]).
:-style_check(-singleton).
:-current_module(prologbasics)->true;use_module('../prologbasics').
:-current_module(basics)->true;use_module('../basics').
:-current_module(version)->true;use_module('../version').
:-current_module(pakcsversion)->true;use_module('../pakcsversion').
:-dynamic dynamicTime/1,dynamicVersion/3,insideTransaction/0.
dynamicTime(1).
setDynamicVersion(_G1451,_G1448/_G1449,_G1453):- (retract(dynamicVersion(_G1451,_G1448/_G1449,_G1460))->true;true),asserta(dynamicVersion(_G1451,_G1448/_G1449,_G1453)).
prim_assertFact('Dynamic.Dynamic'(_G3),'Prelude.()'):-retract(dynamicTime(_G8)),_G15 is _G8+1,assertz(dynamicTime(_G15)),_G3=..[_G22,_G25,_G28,_G31|_G32],_G46=..[_G22,_G15,0|_G32],assertz(user:_G46),logDynamicEvent(_G25,assertz,_G46).
prim_retractFact('Dynamic.Dynamic'(_G97),_G100):-_G97=..[_G102,_G105,_G108,_G111|_G112],_G126=..[_G102,_G120,_G123|_G112],reloadNewestDynamicVersionOf(_G102),retract(dynamicTime(_G131)),_G138 is _G131+1,assertz(dynamicTime(_G138)),call(user:_G126),isInTimeInterval(_G131,_G120,_G123),!,_G163=..[_G102,_G120,_G131|_G112],retract(user:_G126),!,logDynamicEvent(_G105,retract,_G126),assertz(user:_G163),_G100='Prelude.True'.
prim_retractFact(_G246,'Prelude.False').
prim_getDynamicKnowledge(_G264):-reloadNewestDynamicVersions,dynamicTime(_G266),term2partcall('Dynamic.isKnownAtTime'(_G266),1,_G264), (compileWithSharing(function)->makeShare(_G264,_G277);_G277=_G264).
prim_isKnownAtTime(_G316,'Dynamic.Dynamic'(_G314),'Prelude.True'):-_G314=..[_G320,_G323,_G326,_G329|_G330],_G344=..[_G320,_G338,_G341|_G330],call(user:_G344),isInTimeInterval(_G316,_G338,_G341).
isInTimeInterval(_G390,_G391,_G392):-_G390>=_G391, (_G392=0->true;_G390=<_G392).
logDynamicEvent('Dynamic.Temporary',_G438,_G439):-!.
logDynamicEvent('Dynamic.Persistent',_G467,_G468):-_G468=..[_G470,_G473,_G476|_G477],_G491=..[_G470,0,0|_G477],_G500=..[_G467,_G491],user:dynamicPredInfo(_G470/_G504,_G507),logDynamic(_G500,_G507).
logDynamic(_G552,_G553):-dir2tmplockfile(_G553,_G556),lockWithFileIfNotInTransaction(_G556),executeWithFinalize((dir2logfile(_G553,_G561),open(_G561,append,_G565),writeq(_G565,_G552),put_code(_G565,46),nl(_G565),flush_output(_G565),close(_G565),addChangePid(_G553)),unlockWithFileIfNotInTransaction(_G556)).
executeWithFinalize(_G634,_G635):-on_exception(_G639,_G634, (call(_G635),printError(_G639),!,fail)),!,call(_G635).
executeWithFinalize(_G683,_G684):-call(_G684),!,fail.
prim_startTransaction(_G715):- (insideTransaction->writeErr('ERROR: nested transactions not supported!'),nlErr,!,fail;true),assert(insideTransaction),on_exception(_G746,initTransaction(_G715), (unlockAllPersistentDynamics, (retract(insideTransation)->true;true),printError(_G746),fail)),!.
initTransaction(_G787):-lockAllPersistentDynamics,reloadNewestDynamicVersions,retract(dynamicTime(_G789)),_G787 is _G789+1,assertz(dynamicTime(_G787)),logAllDynamicPreds(startTransaction(_G787)).
prim_commitTransaction(_G839,'Prelude.()'):-logAllDynamicPreds(commitTransaction(_G839)),unlockAllPersistentDynamics, (retract(insideTransaction)->true;true).
prim_abortTransaction(_G881):-logAllDynamicPreds(abortTransaction),getDynamicDirs(_G885),map1partialM(prim_dynamic:addChangePid(0),_G885),unlockAllPersistentDynamics, (retract(insideTransaction)->true;true),!,fail.
getDynamicDirs(_G938):-findall(_G940,isDynamicDir(_G940),_G944),sort(_G944,_G938).
isDynamicDir(_G969):-user:dynamicPredInfo(_G971,_G969),\+_G969=''.
logAllDynamicPreds(_G1002):-getDynamicDirs(_G1004),map1partialM(prim_dynamic:logDynamic(_G1002),_G1004).
initializeDynamic:-user:dynamicPredInfo(_G1034/_G1035,_G1038),initializeDynamic(_G1038,_G1034/_G1035),fail.
initializeDynamic.
initializeDynamic('',_G1073/_G1074):-!,retractAllFacts(_G1073/_G1074).
initializeDynamic(_G1111,_G1108/_G1109):-existsDirectory(_G1111),!,checkDynSpec(_G1111,_G1108/_G1109),setDynamicVersion(_G1111,_G1108/_G1109,0),!.
initializeDynamic(_G1162,_G1163):-existsFile(_G1162),!,appendAtom('ERROR: Directory "',_G1162,_G1169),appendAtom(_G1169,'" for dynamic entries cannot be created!',_G1173),writeErr(_G1173),nlErr,!,fail.
initializeDynamic(_G1222,_G1219/_G1220):-upDirectory(_G1222,_G1226), (existsDirectory(_G1226)->createDynamicDir(_G1222,_G1219/_G1220),setDynamicVersion(_G1222,_G1219/_G1220,1);writeErr('>>> Warning: persistent dynamic data directory '),writeErr(_G1222),writeErr(' not accessible!'),nlErr).
upDirectory('.',..):-!.
upDirectory(_G1315,_G1316):-atom_codes(_G1315,_G1319),append(_G1324,[47|_G1322],_G1319),\+member(47,_G1322),!,atom_codes(_G1316,_G1324).
upDirectory(_G1369,'.').
checkDynSpec(_G1390,_G1387/_G1388):-dir2specfile(_G1390,_G1394),existsFile(_G1394),readPrologTermFile(_G1394,_G1399),dynamicSpec(_G1387/_G1388,_G1399),!.
checkDynSpec(_G1440,_G1441):-appendAtom('ERROR: Directory "',_G1440,_G1445),appendAtom(_G1445,'" contains no matching dynamic entries!',_G1449),writeErr(_G1449),nlErr,!,fail.
replayLogFile(_G6,_G3/_G4):-dir2tmplockfile(_G6,_G10),lockWithFileIfNotInTransaction(_G10),executeWithFinalize(replayLogFileWhenAlreadyLocked(_G6,_G3/_G4),unlockWithFileIfNotInTransaction(_G10)).
:-dynamic replayStatus/1.
replayLogFileWhenAlreadyLocked(_G61,_G58/_G59):- (pakcsrc(dynamicmessages,yes)->writeErr('>>> Restoring persistent dynamic data in directory \''),writeErr(_G61),writeErr('\'...'),nlErr;true),getRunTime(_G88),ensurePakcsVersion(_G61),dir2dbfile(_G61,_G93),dir2pofile(_G61,_G96),consultPrologorPOFile(_G93,_G96),dir2logfile(_G61,_G102),open(_G102,read,_G106), (atEndOfStream(_G106)->close(_G106);assert(replayStatus(unchanged)),repeat,on_exception(_G121,readAndReplay(_G106), ((printError(_G121)->true;true),writeErr('ERROR during reading of '),writeErr(_G102),writeErr(' (restored state might be incomplete)'),nlErr)),close(_G106),retract(replayStatus(_G153)),writeNewDatabaseIfChanged(_G58/_G59,_G61,_G153)),updateDynFactsIfNecessary(_G61,_G58/_G59),readDynamicVersion(_G61,_G189),setDynamicVersion(_G61,_G58/_G59,_G189),writeChangePids(_G61,[]), (pakcsrc(dynamicmessages,yes)->writeErr('>>> ...restored in '),getRunTime(_G206),_G211 is _G206-_G88,writeErr(_G211),writeErr(' msec'),nlErr;true),!.
ensurePakcsVersion(_G302):-readPAKCSVersion(_G302,_G305),_G305=pakcsVersion(_G307,_G308),prologMajor(_G313),\+_G313=_G308,dir2pofile(_G302,_G321), (existsFile(_G321)->deleteFile(_G321);true),writePAKCSVersion(_G302),!.
ensurePakcsVersion(_G373).
isCurrentPakcsVersion(_G386):-readPAKCSVersion(_G386,_G389),compilerVersion(_G391),!, (_G389=compilerVersion(_G391)->writePAKCSVersion(_G386);_G389=pakcsVersion(_G391,_G404)).
readPAKCSVersion(_G438,_G439):-dir2pakcsversionfile(_G438,_G442),existsFile(_G442),readPrologTermFile(_G442,_G439).
writePAKCSVersion(_G476):-dir2pakcsversionfile(_G476,_G479),compilerVersion(_G481),prologMajor(_G483),writePrologTermFile(_G479,pakcsVersion(_G481,_G483)).
updateDynFactsIfNecessary(_G517,_G518):-isCurrentPakcsVersion(_G517),!.
updateDynFactsIfNecessary(_G549,_G546/_G547):-compilerVersion(_G552), (pakcsrc(dynamicmessages,yes)->writeErr('>>> Updating persistent dynamic data in directory \''),writeErr(_G549),writeErr('\' to compiler version '),writeErr(_G552),writeErr(...),nlErr;true),updateDynFacts(_G546/_G547),writeNewDatabaseIfChanged(_G546/_G547,_G549,changed),writePAKCSVersion(_G549).
updateDynFactsIfNecessary(_G635,_G636).
updateDynFacts(_G653/_G654):-functor(_G658,_G653,_G654),functor(_G662,_G653,_G654),retract(user:_G658),arg(1,_G658,_G673),arg(1,_G662,_G673),arg(2,_G658,_G681),arg(2,_G662,_G681),translateDynFactArgs(3,_G654,_G658,_G662),asserta(user:_G662),fail.
updateDynFacts(_G741).
translateDynFactArgs(_G754,_G755,_G756,_G757):-_G754>_G755,!.
translateDynFactArgs(_G794,_G795,_G796,_G797):-arg(_G794,_G796,_G801),translateDynFactArg(_G801,_G804),arg(_G794,_G797,_G804),_G813 is _G794+1,translateDynFactArgs(_G813,_G795,_G796,_G797).
translateDynFactArg(_G862,_G862):-var(_G862),!.
translateDynFactArg(_G891,_G891):-number(_G891),!.
translateDynFactArg('True','Prelude.True'):-!.
translateDynFactArg('False','Prelude.False'):-!.
translateDynFactArg('False','Prelude.False'):-!.
translateDynFactArg('Left','Prelude.Left'):-!.
translateDynFactArg('Right','Prelude.Right'):-!.
translateDynFactArg('Nothing','Prelude.Nothing'):-!.
translateDynFactArg('Just','Prelude.Just'):-!.
translateDynFactArg('LT','Prelude.LT'):-!.
translateDynFactArg('GT','Prelude.GT'):-!.
translateDynFactArg('EQ','Prelude.EQ'):-!.
translateDynFactArg(_G1160,_G1161):-atomic(_G1160),atom_codes(_G1160,[40|_G1166]),!,append([80,114,101,108,117,100,101,46,40],_G1166,_G1200),atom_codes(_G1161,_G1200).
translateDynFactArg(_G1238,_G1239):-atom(_G1238),atom_codes(_G1238,[39|_G1244]),!, (_G1244=[_G1249]->char_int(_G1239,_G1249);_G1244=[78,85,76]->char_int(_G1239,0);writeErr('INTERNAL ERROR in translateDynFactArg: unkown char'),nlErr).
translateDynFactArg(_G1320,_G1320):-atomic(_G1320),!.
translateDynFactArg(_G1349,_G1350):-functor(_G1349,_G1353,_G1354),translateDynFactArg(_G1353,_G1357),functor(_G1350,_G1357,_G1354),translateDynFactArgs(1,_G1354,_G1349,_G1350).
writeNewDatabaseIfChanged(_G3/_G4,_G7,changed):-!,dir2dbfile(_G7,_G11),dir2pofile(_G7,_G14),dir2logfile(_G7,_G17),appendAtom(_G11,'.bak',_G21),tell(_G21),writeq((:-dynamic _G3/_G4)),put_code(46),nl,listing(user:_G3/_G4),told,try_save_predicates(_G3/_G4,_G14),renameFile(_G21,_G11),appendAtom(_G17,'.bak',_G55),renameFile(_G17,_G55),appendAtom('touch ',_G17,_G62),shellCmd(_G62),readDynamicVersion(_G7,_G67),_G72 is _G67+1,writeDynamicVersion(_G7,_G72), (pakcsrc(dynamicmessages,yes)->writeErr('>>> ...new database constructed by merging old database and log file '),nlErr;true).
writeNewDatabaseIfChanged(_G177/_G178,_G181,_G182):-dir2logfile(_G181,_G185),appendAtom(_G185,'.bak',_G189),renameFile(_G185,_G189),appendAtom('touch ',_G185,_G196),shellCmd(_G196).
readAndReplay(_G237):-atEndOfStream(_G237),!.
readAndReplay(_G261):-read(_G261,_G264),replayEvent(_G261,_G264).
replayEvent(_G289,end_of_file):-!.
replayEvent(_G315,startTransaction(_G313)):-readAndReplayTransaction(_G315,_G313,[]),!,fail.
replayEvent(_G349,_G350):-retract(replayStatus(_G352)),assert(replayStatus(changed)),call(user:_G350),!,fail.
readAndReplayTransaction(_G398,_G399,_G400):-atEndOfStream(_G398),!, (pakcsrc(dynamicmessages,yes)->writeErr('>>> Warning: ignoring incomplete transaction '),writeErr(_G399),nlErr;true).
readAndReplayTransaction(_G454,_G455,_G456):-read(_G454,_G459), (_G459=commitTransaction(_G455)->callRevList(_G456);_G459=abortTransaction->true;readAndReplayTransaction(_G454,_G455,[_G459|_G456])),!.
callRevList([]).
callRevList([_G534|_G535]):-callRevList(_G535),retract(replayStatus(_G541)),assert(replayStatus(changed)),call(user:_G534).
startTransaction(_G580).
commitTransaction(_G593).
abortTransaction.
lockAllPersistentDynamics:-getDynamicDirs(_G612),map1M(prim_dynamic:lockDynamicDir,_G612).
lockDynamicDir(_G635):-dir2lockfile(_G635,_G638),lockWithFile(_G638).
lockWithFileIfNotInTransaction(_G662):-insideTransaction->true;lockWithFile(_G662).
lockWithFile(_G689):-appendAtom('lockfile-create --lock-name ',_G689,_G693), (existsFile(_G689),pakcsrc(dynamicmessages,yes)->writeErr('>>> Waiting for removing lock file \''),writeErr(_G689),writeErr('\'...'),nlErr;true),shellCmd(_G693),!.
unlockAllPersistentDynamics:-getDynamicDirs(_G752),map1M(prim_dynamic:unlockDynamicDir,_G752).
unlockDynamicDir(_G775):-dir2lockfile(_G775,_G778),unlockWithFile(_G778).
unlockWithFileIfNotInTransaction(_G802):-insideTransaction->true;unlockWithFile(_G802).
unlockWithFile(_G829):-existsFile(_G829),!,appendAtom('lockfile-remove --lock-name ',_G829,_G835),shellCmd(_G835).
unlockWithFile(_G865).
reloadNewestDynamicVersions:-user:dynamicPredInfo(_G878/_G879,_G882),dynamicVersion(_G882,_G878/_G879,_G892),reloadNewestDynamicVersion(_G882,_G878/_G879,_G892),fail.
reloadNewestDynamicVersions.
reloadNewestDynamicVersionOf(_G928):-dynamicVersion(_G933,_G928/_G931,_G935),!,reloadNewestDynamicVersion(_G933,_G928/_G931,_G935).
reloadNewestDynamicVersionOf(_G967).
reloadNewestDynamicVersion(_G983,_G980/_G981,0):-!,retractAllFacts(_G980/_G981),replayLogFile(_G983,_G980/_G981),!.
reloadNewestDynamicVersion(_G1035,_G1032/_G1033,_G1037):-readDynamicVersion(_G1035,_G1040),\+_G1037=_G1040,!,retractAllFacts(_G1032/_G1033),replayLogFile(_G1035,_G1032/_G1033),!.
reloadNewestDynamicVersion(_G1098,_G1099,_G1100):-readChangePids(_G1098,_G1103),currentPID(_G1105), (_G1103=[];_G1103=[_G1105]),!.
reloadNewestDynamicVersion(_G1156,_G1153/_G1154,_G1158):-retractAllFacts(_G1153/_G1154),replayLogFile(_G1156,_G1153/_G1154).
createDynamicDir(_G1202,_G1199/_G1200):- (pakcsrc(dynamicmessages,yes)->writeErr('>>> Creating new persistent dynamic data in directory \''),writeErr(_G1202),writeErr('\'...'),nlErr;true),appendAtom('mkdir -p ',_G1202,_G1231),shellCmd(_G1231),dir2logfile(_G1202,_G1236),appendAtom('touch ',_G1236,_G1240),shellCmd(_G1240),dir2dbfile(_G1202,_G1245),appendAtom('touch ',_G1245,_G1249),shellCmd(_G1249),dir2specfile(_G1202,_G1254),dynamicSpec(_G1199/_G1200,_G1260),writePrologTermFile(_G1254,_G1260),writePAKCSVersion(_G1202).
readPrologTermFile(_G1324,_G1325):-open(_G1324,read,_G1329),read(_G1329,_G1325),close(_G1329).
writePrologTermFile(_G1363,_G1364):-open(_G1363,write,_G1368),writeq(_G1368,_G1364),put_code(_G1368,46),nl(_G1368),flush_output(_G1368),close(_G1368).
readDynamicVersion(_G1418,_G1419):-dir2versionfile(_G1418,_G1422),existsFile(_G1422),!,on_exception(_G1432,readPrologTermFile(_G1422,_G1419),_G1419=0).
readDynamicVersion(_G1466,1).
writeDynamicVersion(_G1484,_G1485):-dir2versionfile(_G1484,_G1488),writePrologTermFile(_G1488,_G1485).
readChangePids(_G3,_G4):-dir2changepidsfile(_G3,_G7),existsFile(_G7),!,on_exception(_G20,readPrologTermFile(_G7,_G4),_G4=[0]).
readChangePids(_G54,[]).
writeChangePids(_G72,_G73):-dir2changepidsfile(_G72,_G76),writePrologTermFile(_G76,_G73).
addChangePid(_G105):-currentPID(_G107),addChangePid(_G107,_G105).
addChangePid(_G132,_G133):-readChangePids(_G133,_G136), (member(_G132,_G136)->true;writeChangePids(_G133,[_G132|_G136])),!.
dynamicSpec(_G180/_G181,dynamicPredicate(_G180,_G181)).
retractDeadDynamicFacts(_G204/_G205):-length(_G209,_G205),_G215=..[_G204|_G209],_G209=[_G218,_G221|_G222],dynamicTime(_G227),call(user:_G215),_G221>0,_G227>_G221,retract(user:_G215),fail.
retractDeadDynamicFacts(_G286).
dir2logfile(_G299,_G300):-appendAtom(_G299,'/eventlog',_G300).
dir2lockfile(_G327,_G328):-appendAtom(_G327,'/LOCK',_G328).
dir2tmplockfile(_G355,_G356):-appendAtom(_G355,'/LOCK',_G356).
dir2dbfile(_G383,_G384):-appendAtom(_G383,'/database.pl',_G384).
dir2pofile(_G411,_G412):-appendAtom(_G411,'/dbpred.po',_G412).
dir2specfile(_G439,_G440):-appendAtom(_G439,'/spec',_G440).
dir2pakcsversionfile(_G467,_G468):-appendAtom(_G467,'/pakcsversion',_G468).
dir2versionfile(_G495,_G496):-appendAtom(_G495,'/version',_G496).
dir2changepidsfile(_G523,_G524):-appendAtom(_G523,'/changepids',_G524).
