:-module(prim_ports,[prim_openPort/3,prim_basicServerLoop/4,prim_sendPort/5,prim_after/4,prim_openProcessPort/2,prim_ping/3,prim_timeoutOnStream/5,prim_openPortOnSocket/3,prim_connectPortAtSocket/4,prim_choiceSPEP/5,checkIncomingPortStreams/3,ifTracePort/1,readPortMessage/4,parse_received_message/4]).
:-style_check(-singleton).
:-current_module(prologbasics)->true;use_module('../prologbasics').
:-current_module(basics)->true;use_module('../basics').
:-current_module(prim_standard)->true;ensure_loaded(user:prim_standard).
:-current_module(prim_readshowterm)->true;use_module(prim_readshowterm).
:-dynamic only_localhost/1,tracePorts/1,mySocket/1,incomingPortStreams/2.
only_localhost(_G2):- (getEnv('PAKCS_LOCALHOST',_G5)->true;_G5=no), (_G5=yes->asserta(only_localhost(yes)),_G2=yes;asserta(only_localhost(no)),_G2=no),retract((only_localhost(_G45):-_G47,_G48)),!.
tracePorts(unknown).
ifTracePort(_G82):-tracePorts(_G84), (_G84=unknown->retract(tracePorts(_G89)), (getEnv('PAKCS_TRACEPORTS',_G94)->true;_G94=no), (_G94=yes->asserta(tracePorts(yes)),_G82;asserta(tracePorts(no)));_G84=yes->_G82;true).
prim_openPort(_G166,_G167,_G168):-nonvar(_G166),!,writeErr('ERROR: openPort: port is not a free variable'),nlErr,fail.
prim_openPort(_G211,_G212,_G213):-nonvar(_G212),!,writeErr('ERROR: openPort: stream is not a free variable'),nlErr,fail.
prim_openPort('Ports.internalPort'([],0,0,_G259),_G259,'Prelude.True').
prim_openPortOnSocket(_G284,_G285,_G286):- (retract(mySocket('Ports.internalPort'(_G288,_G289,_G290,_G291)))->_G300 is _G290+1,asserta(mySocket('Ports.internalPort'(_G288,_G289,_G300,_G291))), (_G284=_G289,_G285=_G300->true;writeErr('ERROR: inconsistent socket/port numbers in openPortOnSocket!'),nlErr);trySetSocketNumber(_G284),on_exception(_G353,listenOnNewSocket(_G284,_G344,_G291), (write('ERROR: openPortOnSocket "'),write(_G284),write('":'),nl,printError(_G353),!,fail)),atom2String(_G344,_G288), (var(_G285)->_G285=0;true),asserta(mySocket('Ports.internalPort'(_G288,_G284,_G285,_G291)))),mySocket(_G415),_G415='Ports.internalPort'(_G417,_G418,_G419,_G420),ifTracePort((writeErr('TRACEPORTS: Listen on port '),writeErr(_G419),writeErr(' at socket '),writeErr(_G418),writeErr(' on host '), (only_localhost(yes)->writeErr(localhost);string2Atom(_G417,_G443),writeErr(_G443)),writeErr(...),nlErr)), (compileWithSharing(function)->makeShare('Ports.basicServerLoop'(_G415),_G286);_G286='Ports.basicServerLoop'(_G415)).
trySetSocketNumber(_G533):-var(_G533),getEnv('PAKCS_SOCKET',_G538),atom_codes(_G538,_G541),number_codes(_G533,_G541),!.
trySetSocketNumber(_G575).
prim_basicServerLoop(_G727,_G728,_G729,_G730):-freeze(_G729,blocked_prim_basicServerLoop(_G727,_G728,_G729,_G730)).
blocked_prim_basicServerLoop(_G761,_G762,_G763,_G764):-readPort(_G761,_G767,-1),_G762=[_G767|_G771], (compileWithSharing(function)->makeShare('Ports.basicServerLoop'(_G761),_G771);_G771='Ports.basicServerLoop'(_G761)),_G763=_G764.
prim_timeoutOnStream(_G975,_G976,_G977,_G978,_G979):-freeze(_G978,blocked_prim_timeoutOnStream(_G975,_G976,_G977,_G978,_G979)).
blocked_prim_timeoutOnStream(_G1014,_G1015,_G1016,_G1017,_G1018):-user:derefRoot(_G1014,_G1021),prim_timeoutOnStream_exec(_G1021,_G1015,_G1016,_G1017,_G1018).
prim_timeoutOnStream_exec(_G1068,_G1069,'Prelude.Nothing',_G1071,_G1072):-var(_G1069),!,_G1071=_G1072.
prim_timeoutOnStream_exec(_G1120,share(_G1118),_G1122,_G1123,_G1124):-!,get_mutable(_G1126,_G1118), (_G1126='$eval'(_G1129)->_G1122=_G1129,_G1123=_G1124;prim_timeoutOnStream_exec(_G1120,_G1126,_G1148,_G1123,_G1124), (_G1148='Prelude.Nothing'->_G1122=_G1148; (compileWithSharing(variable)->user:propagateShare(_G1148,_G1122);_G1148=_G1122),update_mutable('$eval'(_G1122),_G1118))).
prim_timeoutOnStream_exec(_G1236,[],'Prelude.Just'([]),_G1239,_G1240):-!,_G1239=_G1240.
prim_timeoutOnStream_exec(_G1289,[_G1281|_G1282],'Prelude.Just'([_G1281|_G1282]),_G1292,_G1293):-!,_G1292=_G1293.
prim_timeoutOnStream_exec(_G1336,'Ports.basicServerLoop'(_G1334),_G1338,_G1339,_G1340):- (readPort(_G1334,_G1343,_G1336)-> (compileWithSharing(function)->makeShare('Ports.basicServerLoop'(_G1334),_G1351);_G1351='Ports.basicServerLoop'(_G1334)),_G1338='Prelude.Just'([_G1343|_G1351]);_G1338='Prelude.Nothing'),_G1339=_G1340.
send_extvar_binding(_G129,_G130,_G131,_G132):-freeze(_G130,blocked_send_extvar_binding(_G129,_G130,_G131,_G132)).
blocked_send_extvar_binding(_G163,_G164,_G165,_G166):-evalToken(_G168),user:normalizeAndCheck(_G164,_G171,_G168,_G173),user:waitUntilGround(_G171,_G173,_G180),eval_send_extvar_binding(_G163,_G171,_G165,_G180,_G166).
eval_send_extvar_binding(_G381,_G382,_G383,_G384,_G385):-freeze(_G384,blocked_eval_send_extvar_binding(_G381,_G382,_G383,_G384,_G385)).
blocked_eval_send_extvar_binding(nostream,_G421,_G422,_G423,_G424):-writeErr('ERROR: cannot send binding for variable '),writeErr(_G422),writeErr(': '),writeErr(_G421),nlErr,!.
blocked_eval_send_extvar_binding(_G482,_G483,_G484,_G485,_G486):-show4sending(_G483,_G489,_G490),ifTracePort((writeErr('TRACEPORTS: send binding for variable '),writeErr(_G484),writeErr(': '),writeChars(user_error,_G489),nlErr)),number_codes(_G484,_G516),putChars(_G482,[86|_G516]),put_code(_G482,10),writeChars(_G482,_G489),put_code(_G482,10),flush_output(_G482),!,_G486=done.
readPort('Ports.internalPort'(_G598,_G599,_G600,_G601),_G604,_G605):-var(_G601),!,string2Atom(_G598,_G610),writeErr('ERROR: readPort: Port '),writeErr(_G599),writeErr(/),writeErr(_G600),writeErr(@),writeErr(_G610),writeErr(' only opened for writing!'),nlErr.
readPort('Ports.internalPort'(_G681,_G682,_G683,_G684),_G687,_G688):-on_exception(_G695,readFromSocket(_G683,_G684,_G687,_G688), (printError(_G695)->_G687=[];_G687=[])),!.
checkIncomingPortStreams(_G741,_G742,_G743):-retract(incomingPortStreams(_G741,[message(_G742,_G743)|_G749])),asserta(incomingPortStreams(_G741,_G749)),!.
checkIncomingPortStreams(_G792,_G793,_G794):-retract(incomingPortStreams(_G792,[ping(_G796,_G797)|_G800])),asserta(incomingPortStreams(_G792,_G800)),answerPingOnStream(_G796,_G797),checkIncomingPortStreams(_G792,_G793,_G794),!.
answerPingOnStream(_G856,_G857):-write(_G857,ok),put_code(_G857,10),flush_output(_G857),closeSocketStream(_G856,_G857),ifTracePort((writeErr('TRACEPORTS: Ping request answered.'),nlErr)).
readFromSocket(_G910,_G911,_G912,_G913):-checkIncomingPortStreams(_G910,_G916,_G917),!,readStreamLine(_G916,_G920), (parse_received_message(_G916,_G917,_G920,_G912)->ifTracePort((writeErr('TRACEPORTS: Received message: '),putChars(user_error,_G920),nlErr));writeErr('ERROR: Illegal message received (ignored): '),putChars(user_error,_G920),nlErr,readFromSocket(_G910,_G911,_G912,_G913)),!.
readFromSocket(_G1006,_G1007,_G1008,_G1009):-waitForSocketClientStream(_G1007,_G1009,_G1013,_G1014,_G1015),ifTracePort((writeErr('TRACEPORTS: Connection to client: '),writeErr(_G1013),nlErr)), (readPortMessage(_G1006,_G1014,_G1015,_G1032)-> (parse_received_message(_G1014,_G1015,_G1032,_G1008)->ifTracePort((writeErr('TRACEPORTS: Received message: '),putChars(user_error,_G1032),nlErr));writeErr('ERROR: Illegal message received (ignored): '),putChars(user_error,_G1032),nlErr,readFromSocket(_G1006,_G1007,_G1008,_G1009));readFromSocket(_G1006,_G1007,_G1008,_G1009)),!.
readFromSocket(_G1126,_G1127,_G1128,_G1129):-ifTracePort((writeErr('TRACEPORTS: Timeout!'),nlErr)),fail.
readPortMessage(_G1170,_G1171,_G1172,_G1173):-readStreamLine(_G1171,_G1176),_G1176=[_G1178|_G1179],checkMessageHeader(_G1178,_G1171,_G1172,_G1187),number_codes(_G1189,_G1179),!, (_G1189=_G1170->readPortMessageBody(_G1187,_G1173); (retract(incomingPortStreams(_G1189,_G1202))->append(_G1202,[_G1187],_G1211);_G1211=[_G1187]),asserta(incomingPortStreams(_G1189,_G1211)),!,fail).
checkMessageHeader(78,_G1286,_G1287,message(_G1286,_G1287)):-!.
checkMessageHeader(80,_G1323,_G1324,ping(_G1323,_G1324)):-!.
checkMessageHeader(_G1360,_G1361,_G1362,_G1363):-writeErr('ERROR: Illegal message header received.'),nlErr,!,fail.
readPortMessageBody(message(_G1405,_G1406),_G1409):-readStreamLine(_G1405,_G1409).
readPortMessageBody(ping(_G1435,_G1436),_G1439):-answerPingOnStream(_G1435,_G1436),!,fail.
prim_sendPort(_G123,_G124,_G125,_G126,_G127):-freeze(_G126,blocked_prim_sendPort(_G123,_G124,_G125,_G126,_G127)).
blocked_prim_sendPort(_G162,_G163,_G164,_G165,_G166):-user:derefAll(_G162,_G169),user:derefRoot(_G163,_G175),prim_sendPortExec(_G169,_G175,_G164,_G165,_G166).
prim_sendPortExec(_G230,'Ports.internalPort'(_G225,0,_G227,_G228),'Prelude.True',_G233,_G234):-!,add2Stream(_G228,_G230),_G233=_G234.
prim_sendPortExec('Ports.SP_Put'(_G281),'Ports.internalPort'(_G283,-1,_G285,_G286),'Prelude.True',_G291,_G292):-!,user:waitUntilGround(_G281,_G291,_G292),writeChars(_G286,_G281),nl(_G286),flush_output(_G286),ifTracePort((writeErr('TRACEPORTS: SP_Put: '),writeChars(user_error,_G281),nlErr)).
prim_sendPortExec('Ports.SP_GetLine'(_G369),'Ports.internalPort'(_G371,-1,_G373,_G374),'Prelude.True',_G379,_G380):-!,readStreamLine(_G371,_G383),map2M(basics:char_int,_G389,_G383),ifTracePort((writeErr('TRACEPORTS: SP_Get: '),writeChars(user_error,_G389),nlErr)),user:constrEq(_G389,_G369,_G407,_G379,_G380).
prim_sendPortExec('Ports.SP_GetChar'(_G459),'Ports.internalPort'(_G461,-1,_G463,_G464),'Prelude.True',_G469,_G470):-!,get_code(_G461,_G473),char_int(_G473,_G476),ifTracePort((writeErr('TRACEPORTS: SP_GetChar: '),writeErr(_G476),nlErr)),user:constrEq(_G476,_G459,_G492,_G469,_G470).
prim_sendPortExec('Ports.SP_EOF'(_G544),'Ports.internalPort'(_G546,-1,_G548,_G549),'Prelude.True',_G554,_G555):-!, (atEndOfStream(_G546)->_G559='Prelude.True';_G559='Prelude.False'),ifTracePort((writeErr('TRACEPORTS: SP_EOF: '),writeErr(_G559),nlErr)),user:constrEq(_G544,_G559,_G585,_G554,_G555).
prim_sendPortExec('Ports.SP_Close','Ports.internalPort'(_G634,-1,_G636,_G637),'Prelude.True',_G642,_G643):-!,close(_G637),close(_G634),_G642=_G643.
prim_sendPortExec(_G699,'Ports.internalPort'(_G694,-1,_G696,_G697),'Prelude.True',_G702,_G703):-!,writeErr('ERROR: wrong message received by stream port: '),writeErr(_G699),nlErr,_G702=_G703.
prim_sendPortExec(_G762,'Ports.internalPort'(_G757,_G758,_G759,_G760),'Prelude.True',_G765,_G766):-string2Atom(_G757,_G769),on_exception(_G786,send2Socket(_G769,_G758,_G759,_G762), (write('ERROR: send to port '),write(_G759),write(@),write(_G769),write(:),nl, (printError(_G786)->true;true))),_G765=_G766.
add2Stream(_G858,_G859):-var(_G858),!,_G858=[_G859|_G864].
add2Stream([],_G897):-write('ERROR: send: stream has not a free variable at the end'),nl.
add2Stream([_G925|_G926],_G929):-add2Stream(_G926,_G929).
prim_ping(_G962,'Ports.internalPort'(_G955,0,_G957,_G958),'Prelude.Just'(0)):-!.
prim_ping(_G998,'Ports.internalPort'(_G991,-1,_G993,_G994),'Prelude.Just'(0)):-!.
prim_ping(_G1032,'Ports.internalPort'(_G1027,_G1028,_G1029,_G1030),_G1034):-string2Atom(_G1027,_G1037),on_exception(_G1048,ping2SocketPort(_G1037,_G1028,_G1029,_G1032,_G1034),_G1034='Prelude.Nothing').
ping2SocketPort(_G1080,_G1081,_G1082,_G1083,_G1084):-connect2socket(_G1080,_G1081,_G1088,_G1089),number_codes(_G1082,_G1092),putChars(_G1089,[80|_G1092]),put_code(_G1089,10),flush_output(_G1089),getElapsedTime(_G1105),ifTracePort((writeErr('TRACEPORTS: Ping to "'),writeErr(_G1081),writeErr(/),writeErr(_G1082),writeErr(@),writeErr(_G1080),writeErr('"'),nlErr)),waitForInputDataOnStreams([_G1088],_G1083,_G1149), (_G1149=0->readStreamLine(_G1088,_G1155),closeSocketStream(_G1088,_G1089),getElapsedTime(_G1160),_G1165 is _G1160-_G1105,ifTracePort((writeErr('TRACEPORTS: Ping answer received in '),writeErr(_G1165),writeErr(' ms'),nlErr)),_G1084='Prelude.Just'(_G1165);ifTracePort((writeErr('TRACEPORTS: No ping answer received'),nlErr)),_G1084='Prelude.Nothing').
prim_connectPortAtSocket(_G1286,_G1287,_G1288,'Ports.internalPort'(_G1281,_G1282,_G1283,'Prelude.()')):-user:derefRoot(_G1286,_G1282),user:derefRoot(_G1287,_G1283),user:derefAll(_G1288,_G1281),!.
send2Socket(_G1347,_G1348,_G1349,_G1350):-connect2socket(_G1347,_G1348,_G1354,_G1355),number_codes(_G1349,_G1358),putChars(_G1355,[78|_G1358]),put_code(_G1355,10),show4sending(_G1350,_G1370,_G1371),writeChars(_G1355,_G1370),put_code(_G1355,10),flush_output(_G1355),ifTracePort((writeErr('TRACEPORTS: Sent to "'),writeErr(_G1348),writeErr(/),writeErr(_G1349),writeErr(@),writeErr(_G1347),writeErr('": '),writeChars(user_error,_G1370),nlErr)),rev(_G1371,_G1425),receive_extvar_bindings(_G1354,_G1425).
receive_extvar_bindings(_G1489,[]):-!,ifTracePort((writeErr('TRACEPORTS: Closing send-connection'),nlErr)),close(_G1489).
receive_extvar_bindings(_G33,_G34):-readStreamLine(_G33,_G37),_G37=[86|_G40],number_codes(_G45,_G40),readStreamLine(_G33,_G49), (deleteIndexVariable(_G45,_G34,_G53,_G54)->true;writeErr('ERROR: Illegal binding for logical variable received:'),nlErr,_G54=_G34), (parse_received_message(nostream,nostream,_G49,_G76)->ifTracePort((writeErr('TRACEPORTS: Received binding for variable '),writeErr(_G45),writeErr(': '),putChars(user_error,_G49),nlErr));writeErr('ERROR: Illegal message received (ignored): '),putChars(user_error,_G49),nlErr),!,_G53=_G76,receive_extvar_bindings(_G33,_G54).
show4sending(_G169,_G170,_G171):-numberVars(_G169,_G174,[],_G171),show_term(_G174,qualified,_G170,[]).
getVariableIndex(_G217,[ (_G211,_G212)|_G215],_G212):-_G217==_G211,!.
getVariableIndex(_G255,[_G252|_G253],_G257):-getVariableIndex(_G255,_G253,_G257).
getIndexVariable(_G289,[ (_G288,_G289)|_G292],_G288):-!.
getIndexVariable(_G326,[_G323|_G324],_G328):-getIndexVariable(_G326,_G324,_G328).
deleteIndexVariable(_G360,[ (_G359,_G360)|_G363],_G359,_G363):-!.
deleteIndexVariable(_G405,[_G399|_G400],_G407,[_G399|_G403]):-deleteIndexVariable(_G405,_G400,_G407,_G403).
parse_received_message(_G444,_G445,_G446,_G447):-readTerm(_G446,qualified,_G451,_G452),skipWhiteSpace(_G451,[]),extractVars(_G452,_G447,[],_G460),send_extvar_bindings(_G460,_G463,_G445),closeStreamAfterDones(_G463,_G444,_G445).
send_extvar_bindings([],[],_G513).
send_extvar_bindings([ (_G534,_G535)|_G538],[_G540|_G541],_G545):-send_extvar_binding(_G545,_G534,_G535,_G540),send_extvar_bindings(_G538,_G541,_G545).
closeStreamAfterDones([],nostream,_G586):-!.
closeStreamAfterDones([],_G614,_G615):-ifTracePort((writeErr('TRACEPORTS: Closing receive-connection'),nlErr)),closeSocketStream(_G614,_G615).
closeStreamAfterDones([_G655|_G656],_G659,_G660):-closeStreamAfterDones(_G655,_G656,_G659,_G660).
closeStreamAfterDones(_G834,_G835,_G836,_G837):-freeze(_G834,blocked_closeStreamAfterDones(_G834,_G835,_G836,_G837)).
blocked_closeStreamAfterDones(_G868,_G869,_G870,_G871):-closeStreamAfterDones(_G869,_G870,_G871).
prim_openProcessPort(_G911,'Ports.internalPort'(_G906,-1,0,_G909)):-user:derefAll(_G911,_G915),string2Atom(_G915,_G921),execCommand(_G921,_G909,_G906,_G926).
prim_choiceSPEP(_G1101,_G1102,_G1103,_G1104,_G1105):-freeze(_G1102,freeze(_G1104,blocked_prim_choiceSPEP(_G1101,_G1102,_G1103,_G1104,_G1105))).
blocked_prim_choiceSPEP(_G1143,_G1144,_G1145,_G1146,_G1147):-user:derefRoot(_G1143,_G1150),prim_choiceSPEP_exec(_G1150,_G1144,_G1145,_G1146,_G1147).
prim_choiceSPEP_exec(_G1199,share(_G1197),_G1201,_G1202,_G1203):-!,get_mutable(_G1205,_G1197), (_G1205='$eval'(_G1208)->_G1202=_G1203,_G1201='Prelude.Right'(_G1208);prim_choiceSPEP_exec(_G1199,_G1205,_G1229,_G1202,_G1203), (_G1229='Prelude.Left'(_G1233)->_G1201=_G1229;_G1229='Prelude.Right'(_G1244), (compileWithSharing(variable)->user:propagateShare(_G1244,_G1252);_G1244=_G1252),_G1201='Prelude.Right'(_G1252),update_mutable('$eval'(_G1252),_G1197))).
prim_choiceSPEP_exec(_G1341,[_G1333|_G1334],'Prelude.Right'([_G1333|_G1334]),_G1344,_G1345):-!,_G1344=_G1345.
prim_choiceSPEP_exec('Ports.internalPort'(_G1386,-1,_G1388,_G1389),[],_G1393,_G1394,_G1395):-readStreamLine(_G1386,_G1398),map2M(basics:char_int,_G1404,_G1398),ifTracePort((writeErr('TRACEPORTS: SP_Get: '),writeChars(user_error,_G1404),nlErr)),_G1393='Prelude.Left'(_G1404),_G1394=_G1395,!.
prim_choiceSPEP_exec(_G47,'Ports.basicServerLoop'(_G45),_G49,_G50,_G51):-_G45='Ports.internalPort'(_G53,_G54,_G55,_G56),checkIncomingPortStreams(_G55,_G62,_G63),!,readStreamLine(_G62,_G66), (compileWithSharing(function)->makeShare('Ports.basicServerLoop'(_G45),_G73);_G73='Ports.basicServerLoop'(_G45)), (parse_received_message(_G62,_G63,_G66,_G89)->ifTracePort((writeErr('TRACEPORTS: Received message: '),writeErr(_G89),nlErr)),_G49='Prelude.Right'([_G89|_G73]);writeErr('ERROR: Illegal message received (ignored): '),putChars(user_error,_G66),nlErr,prim_choiceSPEP_exec(_G47,_G73,_G49,_G50,_G51)),_G50=_G51,!.
prim_choiceSPEP_exec('Ports.internalPort'(_G197,-1,_G199,_G200),'Ports.basicServerLoop'(_G202),_G206,_G207,_G208):-_G202='Ports.internalPort'(_G210,_G211,_G212,_G213),waitForSocketOrInputStreams(_G213,_G222,_G223,_G224,[_G197],_G226), (compileWithSharing(function)->makeShare('Ports.basicServerLoop'(_G202),_G233);_G233='Ports.basicServerLoop'(_G202)), (_G222=no->readStreamLine(_G197,_G250),map2M(basics:char_int,_G256,_G250),ifTracePort((writeErr('TRACEPORTS: SP_Get: '),writeChars(user_error,_G256),nlErr)),_G206='Prelude.Left'(_G256);ifTracePort((writeErr('TRACEPORTS: Connection to client: '),writeErr(_G222),nlErr)), (readPortMessage(_G212,_G223,_G224,_G304)-> (parse_received_message(_G223,_G224,_G304,_G309)->ifTracePort((writeErr('TRACEPORTS: Received message: '),writeErr(_G309),nlErr)),_G206='Prelude.Right'([_G309|_G233]);writeErr('ERROR: Illegal message received (ignored): '),putChars(user_error,_G304),nlErr,prim_choiceSPEP_exec('Ports.internalPort'(_G197,-1,_G344,_G200),_G233,_G206,_G207,_G208));prim_choiceSPEP_exec('Ports.internalPort'(_G197,-1,_G370,_G200),_G233,_G206,_G207,_G208))),_G207=_G208,!.
numberVars(_G441,'VAR'(_G439),_G443,_G444):-var(_G441),!, (getVariableIndex(_G441,_G443,_G439)->_G444=_G443;length(_G443,_G439),_G444=[ (_G441,_G439)|_G443]).
numberVars(_G511,_G512,_G513,_G514):-isShowableArg(_G511),_G511=..[_G518|_G519],numberVarsList(_G519,_G525,_G513,_G514),_G512=..[_G518|_G525].
numberVarsList([],[],_G575,_G575).
numberVarsList([_G601|_G602],[_G604|_G605],_G609,_G610):-numberVars(_G601,_G604,_G609,_G615),numberVarsList(_G602,_G605,_G615,_G610).
extractVars(_G654,_G654,_G656,_G656):-var(_G654),!.
extractVars('VAR'(_G693),_G696,_G697,_G698):-!, (getIndexVariable(_G693,_G697,_G696)->_G698=_G697;_G698=[ (_G696,_G693)|_G697]).
extractVars(_G754,_G755,_G756,_G757):-_G754=..[_G759|_G760],extractVarsList(_G760,_G766,_G756,_G757),_G755=..[_G759|_G766].
extractVarsList([],[],_G813,_G813).
extractVarsList([_G839|_G840],[_G842|_G843],_G847,_G848):-extractVars(_G839,_G842,_G847,_G853),extractVarsList(_G840,_G843,_G853,_G848).
prim_after(_G1001,_G1002,_G1003,_G1004):-freeze(_G1003,blocked_prim_after(_G1001,_G1002,_G1003,_G1004)).
blocked_prim_after(_G1035,_G1036,_G1037,_G1037):-raise_exception('Ports.after not implemented!').
