%PAKCS1.14 swi7 VARIABLESHARING

:-noSingletonWarnings.
:-noRedefineWarnings.
:-noDiscontiguousWarnings.

:-importModule('Maybe').
:-importModule('Prelude').
:-importModule('RedBlackTree').


:-curryModule('Set').

%%%%%%%%%%%% function types %%%%%%%%%%%%%%%%%%%
:-multifile functiontype/6.
:-dynamic functiontype/6.
functiontype('Set.empty',empty,0,'Set.empty',nofix,'TCons'('RedBlackTree.RedBlackTree',[_G713118])).
functiontype('Set.null',null,0,'Set.null',nofix,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G722030]),'TCons'('Prelude.Bool',[]))).
functiontype('Set.elem',elem,1,'Set.elem',nofix,'FuncType'(_G730900,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G730900]),'TCons'('Prelude.Bool',[])))).
functiontype('Set.insert',insert,0,'Set.insert',nofix,'FuncType'(_G739860,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G739860]),'TCons'('RedBlackTree.RedBlackTree',[_G739860])))).
functiontype('Set.delete',delete,0,'Set.delete',nofix,'FuncType'(_G748862,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G748862]),'TCons'('RedBlackTree.RedBlackTree',[_G748862])))).
functiontype('Set.toList',toList,0,'Set.toList',nofix,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G757945]),'TCons'([],[_G757945]))).
functiontype('Set.fromList',fromList,0,'Set.fromList',nofix,'FuncType'('TCons'([],[_G766800]),'TCons'('RedBlackTree.RedBlackTree',[_G766800]))).
functiontype('Set.union',union,1,'Set.union',nofix,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G775796]),'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G775796]),'TCons'('RedBlackTree.RedBlackTree',[_G775796])))).
functiontype('Set.intersect',intersect,2,'Set.intersect',nofix,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G784888]),'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G784888]),'TCons'('RedBlackTree.RedBlackTree',[_G784888])))).
functiontype('Set.disjoint',disjoint,2,'Set.disjoint',nofix,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G793977]),'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G793977]),'TCons'('Prelude.Bool',[])))).

%%%%%%%%%%%% constructor types %%%%%%%%%%%%%%%%%%%
:-multifile constructortype/7.
:-dynamic constructortype/7.

%%%%%%%%%%%% function definitions %%%%%%%%%%%%%%%%%%%
'Set.empty'(_G815119,_G815120,_G815121):-freeze(_G815120,'blocked_Set.empty'(_G815119,_G815120,_G815121)).
'blocked_Set.empty'(_G815277,_G815280,_G815283):-hnf('RedBlackTree.empty'(partcall(2,'Prelude.==',[]),partcall(2,'Prelude.==',[]),partcall(2,'Prelude.<',[])),_G815277,_G815280,_G815283).

'Set.null'(_G815943,_G815944,_G815945):-freeze(_G815944,'blocked_Set.null'(_G815943,_G815944,_G815945)).
'blocked_Set.null'(_G815981,_G815984,_G815987):-hnf(partcall(1,'RedBlackTree.isEmpty',[]),_G815981,_G815984,_G815987).

'Set.elem'(_G816337,_G816338,_G816339,_G816340):-freeze(_G816339,'blocked_Set.elem'(_G816337,_G816338,_G816339,_G816340)).
'blocked_Set.elem'(_G816375,_G816502,_G816505,_G816508):-hnf('Prelude..'(partcall(1,'Maybe.isJust',[]),partcall(1,'RedBlackTree.lookup',[_G816375])),_G816502,_G816505,_G816508).

'Set.insert'(_G817150,_G817151,_G817152):-freeze(_G817151,'blocked_Set.insert'(_G817150,_G817151,_G817152)).
'blocked_Set.insert'(_G817188,_G817191,_G817194):-hnf(partcall(2,'RedBlackTree.update',[]),_G817188,_G817191,_G817194).

'Set.delete'(_G817583,_G817584,_G817585):-freeze(_G817584,'blocked_Set.delete'(_G817583,_G817584,_G817585)).
'blocked_Set.delete'(_G817621,_G817624,_G817627):-hnf(partcall(2,'RedBlackTree.delete',[]),_G817621,_G817624,_G817627).

'Set.toList'(_G818016,_G818017,_G818018):-freeze(_G818017,'blocked_Set.toList'(_G818016,_G818017,_G818018)).
'blocked_Set.toList'(_G818054,_G818057,_G818060):-hnf(partcall(1,'RedBlackTree.tree2list',[]),_G818054,_G818057,_G818060).

'Set.fromList'(_G818494,_G818495,_G818496):-freeze(_G818495,'blocked_Set.fromList'(_G818494,_G818495,_G818496)).
'blocked_Set.fromList'(_G818612,_G818615,_G818618):-hnf(partcall(1,'Prelude.foldr',['Set.empty','Set.insert']),_G818612,_G818615,_G818618).

'Set.union'(_G819132,_G819133,_G819134,_G819135):-freeze(_G819134,'blocked_Set.union'(_G819132,_G819133,_G819134,_G819135)).
'blocked_Set.union'(_G819170,_G819337,_G819340,_G819343):-hnf('Prelude..'(partcall(1,'Prelude.foldr',[_G819170,'Set.insert']),'Set.toList'),_G819337,_G819340,_G819343).

'Set.intersect'(_G820096,_G820097,_G820098,_G820099,_G820100):-freeze(_G820099,'blocked_Set.intersect'(_G820096,_G820097,_G820098,_G820099,_G820100)).
'blocked_Set.intersect'(_G820139,_G820148,_G820508,_G820511,_G820514):-hnf('Prelude.$'('Set.fromList','Prelude.$'(partcall(1,'Prelude.filter',[partcall(1,'Prelude.flip',[_G820148,partcall(1,'Set.elem',[])])]),'Prelude.apply'('Set.toList',_G820139))),_G820508,_G820511,_G820514).

'Set.disjoint'(_G821694,_G821695,_G821696,_G821697,_G821698):-freeze(_G821697,'blocked_Set.disjoint'(_G821694,_G821695,_G821696,_G821697,_G821698)).
'blocked_Set.disjoint'(_G821737,_G821746,_G821906,_G821909,_G821912):-hnf('Prelude.apply'('Set.null','Set.intersect'(_G821737,_G821746)),_G821906,_G821909,_G821912).

:-costCenters(['']).




%%%%% Number of shared variables: 0
